## vimix 0.9.0+ds

=== CMakeLists.txt ===
#####
#####  This file is part of vimix - video live mixer
#####  **Copyright** (C) 2019-2023 Bruno Herbelin <bruno.herbelin@gmail.com>
#####

cmake_minimum_required(VERSION 3.10)
project(vimix VERSION 0.0.1 LANGUAGES CXX C)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

#####
##### Use git to read version from tags
#####
find_package (Git)
if(GIT_EXECUTABLE)
  execute_process(
    COMMAND ${GIT_EXECUTABLE} describe --tags
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    OUTPUT_VARIABLE GIT_DESCRIBE_VERSION
    RESULT_VARIABLE GIT_DESCRIBE_ERROR_CODE
    OUTPUT_STRIP_TRAILING_WHITESPACE
    )
  if(NOT GIT_DESCRIBE_ERROR_CODE)
      string(SUBSTRING ${GIT_DESCRIBE_VERSION} 0 1 VIMIX_VERSION_MAJOR)
      string(SUBSTRING ${GIT_DESCRIBE_VERSION} 2 1 VIMIX_VERSION_MINOR)
      string(LENGTH ${GIT_DESCRIBE_VERSION} VIMIX_VERSION_LENGTH)
      if (VIMIX_VERSION_LENGTH GREATER 4)
          string(SUBSTRING ${GIT_DESCRIBE_VERSION} 4 1 VIMIX_VERSION_PATCH)
      else()
          set(VIMIX_VERSION_PATCH "0")
      endif()
      add_definitions(-DVIMIX_GIT="${GIT_DESCRIBE_VERSION}")
      add_definitions(-DVIMIX_VERSION_MAJOR=${VIMIX_VERSION_MAJOR})
      add_definitions(-DVIMIX_VERSION_MINOR=${VIMIX_VERSION_MINOR})
      add_definitions(-DVIMIX_VERSION_PATCH=${VIMIX_VERSION_PATCH})
      message(STATUS "Compiling vimix \n   version ${VIMIX_VERSION_MAJOR}.${VIMIX_VERSION_MINOR}.${VIMIX_VERSION_PATCH} (${GIT_DESCRIBE_VERSION})\n")
  endif()
endif()

if (NOT GIT_EXECUTABLE OR GIT_DESCRIBE_ERROR_CODE)
    #####
    ##### Fallback: Read version from snap/snapcraft.yaml if git is not available
    #####
    set(SNAPCRAFT_YAML "${CMAKE_CURRENT_SOURCE_DIR}/snap/snapcraft.yaml")
    if(EXISTS ${SNAPCRAFT_YAML})
    file(READ ${SNAPCRAFT_YAML} SNAPCRAFT_CONTENT)
    # Extract version line: "version: '0.8.5d'"
    string(REGEX MATCH "version: *'([0-9]+)\\.([0-9]+)\\.([0-9]+)?([a-z])?'" VERSION_MATCH ${SNAPCRAFT_CONTENT})
    if(VERSION_MATCH)
        set(VIMIX_VERSION_MAJOR ${CMAKE_MATCH_1})
        set(VIMIX_VERSION_MINOR ${CMAKE_MATCH_2})
        set(VIMIX_VERSION_PATCH ${CMAKE_MATCH_3})
        add_definitions(-DVIMIX_VERSION_MAJOR=${VIMIX_VERSION_MAJOR})
        add_definitions(-DVIMIX_VERSION_MINOR=${VIMIX_VERSION_MINOR})
        add_definitions(-DVIMIX_VERSION_PATCH=${VIMIX_VERSION_PATCH})
        message(STATUS "Compiling vimix \n   version ${VIMIX_VERSION_MAJOR}.${VIMIX_VERSION_MINOR}.${VIMIX_VERSION_PATCH}\n")
    endif()
    endif()
endif()


#####
##### Find the cmake modules
#####

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} /usr/share/cmake ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules )
include(MacroLogFeature)
include(MacroFindGStreamerLibrary)


#####
##### Configure cmake
#####

set(BUILD_STATIC_LIBS ON)
set(CMAKE_INCLUDE_CURRENTDIR ON)

if(UNIX)
    if (APPLE)
        add_definitions(-DAPPLE)

        # the RPATH to be used when installing
        set(CMAKE_SKIP_RPATH TRUE)
        set(OpenGL_DIR /Library/Developer/CommandLineTools/SDKs/MacOSX.sdk/System/Library/Frameworks/)

        # MacOS target
        set(CMAKE_OSX_ARCHITECTURES "arm64" CACHE STRING "")
        set(CMAKE_OSX_DEPLOYMENT_TARGET "13" CACHE STRING "")

        # CPACK
        set(CPACK_SYSTEM_NAME  "OSX_${CMAKE_OSX_DEPLOYMENT_TARGET}_${CMAKE_OSX_ARCHITECTURES}")
        set(CPACK_GENERATOR DragNDrop)
        set(CPACK_BINARY_DRAGNDROP ON)

        # Apple ID code signing
        set(APPLE_CODESIGN_ENTITLEMENTS "${CMAKE_CURRENT_SOURCE_DIR}/osx/entitlements.plist")
        ## team ID, for example if your certificate is: Developer ID Application: JOHN, DOE (X4MF6H9XZ6) the team ID is: X4MF6H9XZ6
        set(APPLE_CODESIGN_TEAM "" CACHE STRING "")
        ## Apple identity, in the form Developer ID Application
        set(APPLE_CODESIGN_IDENTITY "Developer ID Application:" CACHE STRING "")
        ## Apple keychain profile for app-specific password
        ## 1. Create a password for "vimix" at  https://support.apple.com/en-us/102654
        ## 2. Run e.g.
        ## xcrun notarytool store-credentials "vimix" --apple-id <email_login_apple_id> --team-id <team> --password <string_given_https://appleid.apple.com/account/manage>
        set(APPLE_CODESIGN_STORED_CREDENTIAL "vimix" CACHE STRING "")

        # find icu4c in OSX (pretty well hidden...)
        set(ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/usr/local/opt/icu4c/lib/pkgconfig:/opt/homebrew/opt/icu4c/lib/pkgconfig")

    else()
        add_definitions(-DLINUX)

        # CPACK
        set(CPACK_SYSTEM_NAME "${CMAKE_HOST_SYSTEM_NAME}")

        # linux opengl
        set(OpenGL_GL_PREFERENCE "GLVND")

        # linux dialogs use GTK
        find_package(GTK 3.0 REQUIRED)
        macro_log_feature(GTK_FOUND "GTK" "GTK cross-platform widget toolkit" "http://www.gtk.org" TRUE)

        find_package(X11 REQUIRED COMPONENTS xcb)
        include_directories(
            ${X11_INCLUDE_DIR}
        )

        # XInput2 for tablet pressure support (optional)
        find_package(X11 COMPONENTS Xi)
        if(X11_Xi_FOUND)
            add_definitions(-DHAVE_X11TABLETINPUT)
            macro_log_feature(X11_Xi_FOUND "XInput2" "X11 Input extension for tablet support" "https://www.x.org/wiki/" FALSE)
        else()
       
            # alternatively libinput and libudev for tablet pressure support
            if (PKG_CONFIG_FOUND)
                pkg_check_modules(LIBINPUT libinput>=1.19)
                pkg_check_modules(LIBUDEV libudev)
            endif()

            if(LIBINPUT_FOUND AND LIBUDEV_FOUND)
                include_directories(${LIBINPUT_INCLUDE_DIRS} ${LIBUDEV_INCLUDE_DIRS})
                link_directories(${LIBINPUT_LIBRARY_DIRS} ${LIBUDEV_LIBRARY_DIRS})
                add_definitions(-DHAVE_LIBINPUT)
                macro_log_feature(LIBINPUT_FOUND "libinput" "Input device library for tablet support" "https://wayland.freedesktop.org/libinput" FALSE)
                macro_log_feature(LIBUDEV_FOUND "libudev" "Device management library" "https://www.freedesktop.org/software/systemd/man/libudev.html" FALSE)
            else()
                message(STATUS "XInput2 (Xi) or libinput or libudev not found - tablet pressure support will be disabled")
            endif()
        endif()

    endif()
    add_definitions(-DUNIX)
elseif(WIN32)
    add_definitions(-DWIN32)
    add_definitions(-DMINGW32)
endif()

#####
##### Preprocessor options
#####

option(USE_GST_OPENGL_SYNC_HANDLER "Enable GStreamer OpenGL sync handler" ON)
if(USE_GST_OPENGL_SYNC_HANDLER AND NOT APPLE)
    add_definitions(-DUSE_GST_OPENGL_SYNC_HANDLER)
endif()
# add_definitions(-DUSE_GL_BUFFER_SUBDATA)

#####
##### Dependencies
#####

#
# Basics
#
set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
find_package(Threads REQUIRED)
find_package(ZLIB REQUIRED)

#
# GSTREAMER
#
if (PKG_CONFIG_FOUND)
    pkg_check_modules(GSTREAMER REQUIRED gstreamer-1.0>=1.24
        gstreamer-base-1.0
        gstreamer-pbutils-1.0
        gstreamer-app-1.0
        gstreamer-audio-1.0
        gstreamer-video-1.0
        gstreamer-gl-1.0
        gstreamer-transcoder-1.0
    )

    include_directories(
        ${GSTREAMER_INCLUDE_DIRS}
    )

    link_directories(
        ${GSTREAMER_LIBRARY_DIRS}
    )

else ()
    find_package(GLIB2 REQUIRED)
    macro_log_feature(GLIB2_FOUND "GLib" "GTK general-purpose utility library" "http://www.gtk.org" TRUE)

    find_package(GObject REQUIRED)
    macro_log_feature(GOBJECT_FOUND "GObject" "GTK object-oriented framework" "http://www.gtk.org" TRUE)

    find_package(GStreamer 1.0 COMPONENTS base REQUIRED)

    find_package(GStreamerPluginsBase 1.0.0 COMPONENTS app audio video pbutils gl transcoder)
    macro_log_feature(GSTREAMER_APP_LIBRARY_FOUND "GStreamerPluginsBase" "GStreamer app library"
    "http://gstreamer.freedesktop.org/" TRUE "1.0.0")
    macro_log_feature(GSTREAMER_AUDIO_LIBRARY_FOUND "GStreamerPluginsBase" "GStreamer audio library"
    "http://gstreamer.freedesktop.org/" TRUE "1.0.0")
    macro_log_feature(GSTREAMER_VIDEO_LIBRARY_FOUND "GStreamerPluginsBase" "GStreamer video library"
    "http://gstreamer.freedesktop.org/" TRUE "1.0.0")
    macro_log_feature(GSTREAMER_PBUTILS_LIBRARY_FOUND "GStreamerPluginsBase" "GStreamer pbutils library"
    "http://gstreamer.freedesktop.org/" TRUE "1.0.0")
    macro_log_feature(GSTREAMER_GL_LIBRARY_FOUND "GStreamerPluginsBase" "GStreamer opengl library"
    "http://gstreamer.freedesktop.org/" TRUE "1.0.0")
    macro_log_feature(GSTREAMER_TRANSCODER_LIBRARY_FOUND "GStreamerPluginsBase" "GStreamer transcoder library"
    "http://gstreamer.freedesktop.org/" TRUE "1.0.0")

    include_directories(
        ${GLIB2_INCLUDE_DIR}
        ${GSTREAMER_INCLUDE_DIR}
        ${GSTREAMER_AUDIO_INCLUDE_DIR}
        ${GSTREAMER_VIDEO_INCLUDE_DIR}
        ${GSTREAMER_BASE_INCLUDE_DIR}
        ${GSTREAMER_APP_INCLUDE_DIR}
        ${GSTREAMER_PBUTILS_INCLUDE_DIR}
        ${GSTREAMER_GL_INCLUDE_DIR}
        ${GSTREAMER_TRANSCODER_INCLUDE_DIR}
    )
    set( GSTREAMER_LIBRARIES
        ${GOBJECT_LIBRARIES}
        ${GSTREAMER_LIBRARY}
        ${GSTREAMER_BASE_LIBRARY}
        ${GSTREAMER_APP_LIBRARY}
        ${GSTREAMER_AUDIO_LIBRARY}
        ${GSTREAMER_VIDEO_LIBRARY}
        ${GSTREAMER_PBUTILS_LIBRARY}
        ${GSTREAMER_GL_LIBRARY}
        ${GSTREAMER_TRANSCODER_LIBRARY}
    )

endif ()


# Various preprocessor definitions for GST
add_definitions(-DGST_DISABLE_XML -DGST_DISABLE_LOADSAVE)

#
# ICU4C
#
if (PKG_CONFIG_FOUND)
    pkg_check_modules(ICU REQUIRED icu-i18n icu-uc icu-io)
else ()
    find_package(ICU REQUIRED COMPONENTS i18n io uc)
endif ()

macro_log_feature(ICU_FOUND "ICU" "International Components for Unicode" "http://site.icu-project.org" TRUE)

include_directories(
    ${ICU_INCLUDE_DIRS}
)

link_directories(
    ${ICU_LIBRARY_DIRS}
)

#
# GLFW3
#
if (PKG_CONFIG_FOUND)
    pkg_check_modules(GLFW3 REQUIRED glfw3>=3.2)
else ()
    find_package(glfw3 3.2 REQUIRED)
endif()

macro_log_feature(GLFW3_FOUND "glfw3" "Open Source multi-platform library for OpenGL" "http://www.glfw.org" TRUE)

include_directories(
    ${GLFW3_INCLUDE_DIRS}
)

link_directories(
    ${GLFW3_LIBRARY_DIRS}
)

#
# GLM
#
if (PKG_CONFIG_FOUND)
    pkg_check_modules(GLM QUIET glm>=0.9.9)
else ()
    find_package(glm 0.9.9 QUIET)
endif()

if (GLM_FOUND)
    macro_log_feature(GLM_FOUND "GLM" "OpenGL mathematics" "https://glm.g-truc.net" TRUE)
else ()
    set(GLM_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/ext/glm)
    add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/ext/glm)
    message(STATUS "Compiling 'GLM' OpenGL mathematics https://glm.g-truc.net -- ${CMAKE_CURRENT_SOURCE_DIR}/ext/glm")
endif()

include_directories(
    ${GLM_INCLUDE_DIRS}
)

#
# TINY XML 2
#
if (PKG_CONFIG_FOUND)
    pkg_check_modules(TINYXML2 QUIET tinyxml2>=8.0)
else ()
    find_package(tinyxml2 8.0 QUIET)
endif()

if (TINYXML2_FOUND)
    macro_log_feature(TINYXML2_FOUND "TinyXML2" "TinyXML2 library" "https://github.com/leethomason/tinyxml2.git" TRUE)
else ()
    set(TINYXML2_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/ext/tinyxml2)
    set(TINYXML2_LIBRARIES TINYXML2)
    add_library(TINYXML2 "${CMAKE_CURRENT_SOURCE_DIR}/ext/tinyxml2/tinyxml2.cpp")
    set_property(TARGET TINYXML2 PROPERTY CXX_STANDARD 17)
    set_property(TARGET TINYXML2 PROPERTY C_STANDARD 11)
    message(STATUS "Compiling 'TinyXML2' from https://github.com/leethomason/tinyxml2.git -- ${TINYXML2_INCLUDE_DIRS}")
endif()

include_directories(
    ${TINYXML2_INCLUDE_DIRS}
)

#
# STB
#
if (PKG_CONFIG_FOUND)
    pkg_check_modules(STB QUIET stb)
else ()
    find_package(stb QUIET)
endif()

if (STB_FOUND)
    macro_log_feature(STB_FOUND "STB" "single-file image and audio processing" "https://github.com/nothings/stb" TRUE)
else ()
    set(STB_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/ext/stb)
    message(STATUS "Including 'STB' single-file image and audio processing from https://github.com/nothings/stb -- ${STB_INCLUDE_DIRS}")
endif()

include_directories(
    ${STB_INCLUDE_DIRS}
)

#
# Ableton LINK
#
find_package(AbletonLink QUIET)

if (AbletonLink_FOUND)

=== src/CMakeLists.txt ===
#####
#####  This file is part of vimix - video live mixer
#####  **Copyright** (C) 2019-2023 Bruno Herbelin <bruno.herbelin@gmail.com>
#####

cmake_minimum_required(VERSION 3.10)
include( InstallRequiredSystemLibraries )

#####
##### VIMIX TARGET BINARY
#####

set(VMIX_BINARY "vimix")
set(VMIX_SRCS
    # Main source files
    main.cpp
    Log.cpp
    ActionManager.cpp
    Audio.cpp
    Canvas.cpp
    Connection.cpp
    ControlManager.cpp
    FrameBuffer.cpp
    FrameGrabber.cpp
    FrameGrabbing.cpp
    Interpolator.cpp
    Loopback.cpp
    MainWindow.cpp
    MediaPlayer.cpp
    Metronome.cpp
    Mixer.cpp
    MixingGroup.cpp
    MousePointer.cpp
    MultiFileRecorder.cpp
    Navigator.cpp
    OutputWindow.cpp
    Overlay.cpp
    Playlist.cpp
    Recorder.cpp
    RenderingManager.cpp
    Resource.cpp
    Screenshot.cpp
    Selection.cpp
    Session.cpp
    SessionCreator.cpp
    SessionParser.cpp
    Settings.cpp
    Shader.cpp
    ImageShader.cpp
    ImageProcessingShader.cpp
    ShmdataBroadcast.cpp
    Stream.cpp
    Streamer.cpp
    TabletInput.cpp
    Timeline.cpp
    Transcoder.cpp
    UserInterfaceManager.cpp
    VideoBroadcast.cpp
    
    # Filter/ folder
    Filter/DelayFilter.cpp
    Filter/FrameBufferFilter.cpp
    Filter/ImageFilter.cpp
    
    # Scene/ folder
    Scene/Decorations.cpp
    Scene/Grid.cpp
    Scene/Mesh.cpp
    Scene/Primitives.cpp
    Scene/Scene.cpp
    Scene/UpdateCallback.cpp
    
    # Source/ folder
    Source/CloneSource.cpp
    Source/DeviceSource.cpp
    Source/MediaSource.cpp
    Source/MultiFileSource.cpp
    Source/NetworkSource.cpp
    Source/PatternSource.cpp
    Source/RenderSource.cpp
    Source/ScreenCaptureSource.cpp
    Source/SessionSource.cpp
    Source/ShaderSource.cpp
    Source/Source.cpp
    Source/SourceCallback.cpp
    Source/SourceList.cpp
    Source/SrtReceiverSource.cpp
    Source/StreamSource.cpp
    Source/TextSource.cpp
    Source/CanvasSource.cpp
    
    # Toolkit/ folder
    Toolkit/BaseToolkit.cpp
    Toolkit/DialogToolkit.cpp
    Toolkit/GlmToolkit.cpp
    Toolkit/GstToolkit.cpp
    Toolkit/ImGuiToolkit.cpp
    Toolkit/NetworkToolkit.cpp
    Toolkit/SystemToolkit.cpp
    Toolkit/tinyxml2Toolkit.cpp
    
    # View/ folder
    View/DisplaysView.cpp
    View/GeometryView.cpp
    View/GeometryHandleManipulation.cpp
    View/LayerView.cpp
    View/MixingView.cpp
    View/RenderView.cpp
    View/TextureView.cpp
    View/TransitionView.cpp
    View/View.cpp
    
    # Visitor/ folder
    Visitor/BoundingBoxVisitor.cpp
    Visitor/CountVisitor.cpp
    Visitor/DrawVisitor.cpp
    Visitor/ImGuiVisitor.cpp
    Visitor/InfoVisitor.cpp
    Visitor/PickingVisitor.cpp
    Visitor/SearchVisitor.cpp
    Visitor/SessionVisitor.cpp
    
    # Window/ folder
    Window/InputMappingWindow.cpp
    Window/OutputPreviewWindow.cpp
    Window/ShaderEditWindow.cpp
    Window/SourceControlWindow.cpp
    Window/TimerMetronomeWindow.cpp
    Window/WorkspaceWindow.cpp
)

#####
##### DEFINE THE TARGET (OS specific)
#####

IF(APPLE)

    # Add macOS tablet input implementation
    list(APPEND VMIX_SRCS ${CMAKE_SOURCE_DIR}/osx/TabletInput_macos.mm)
    # Enable Objective-C++
    set_source_files_properties(${CMAKE_SOURCE_DIR}/osx/TabletInput_macos.mm PROPERTIES COMPILE_FLAGS "-x objective-c++")

ELSE(APPLE)

    if (USE_GST_OPENGL_SYNC_HANDLER)
        # Add GPU video recorder implementation
        list(APPEND VMIX_SRCS GPUVideoRecorder.cpp)
    endif()

    # Add Linux tablet input implementation
    if(X11_Xi_FOUND)
        # Use X11/XInput2 version (works in Flatpak and everywhere)
        list(APPEND VMIX_SRCS TabletInput_x11.cpp)
    else()
        if(LIBINPUT_FOUND AND LIBUDEV_FOUND)
            # Use X11/XInput2 version (works in Flatpak and everywhere)
            list(APPEND VMIX_SRCS TabletInput_linux_libinput.cpp)
        endif()
    endif()

ENDIF(APPLE)

IF(APPLE)

    # set icon
    set(MACOSX_BUNDLE_ICON vimix.icns)
    set(MACOSX_BUNDLE_ICON_FILE ${CMAKE_SOURCE_DIR}/osx/${MACOSX_BUNDLE_ICON})
    # set where in the bundle to put the icns file
    set_source_files_properties(${MACOSX_BUNDLE_ICON_FILE} PROPERTIES MACOSX_PACKAGE_LOCATION Resources)

    # create the application
    add_executable(${VMIX_BINARY} MACOSX_BUNDLE
        ${VMIX_SRCS}
        ${MACOSX_BUNDLE_ICON_FILE}
    )

    # set the Info.plist file
    set(MACOSX_BUNDLE_PLIST_FILE ${CMAKE_SOURCE_DIR}/osx/Info.plist.in)
    set_target_properties(${VMIX_BINARY} PROPERTIES
        MACOSX_BUNDLE_INFO_PLIST ${MACOSX_BUNDLE_PLIST_FILE}
    )

    # link with base frameworks
    set(PLATFORM_LIBS
        "-framework CoreFoundation"
        "-framework Appkit"
    )

ELSE(APPLE)

    link_directories (${GTK3_LIBRARY_DIRS})

    add_executable(${VMIX_BINARY}
        ${VMIX_SRCS}
    )

    set(PLATFORM_LIBS
        GTK::GTK
        X11::X11
        X11::xcb
    )

    # Add XInput2 library for tablet support on Linux (if available)
    if(X11_Xi_FOUND)
        list(APPEND PLATFORM_LIBS ${X11_Xi_LIB})
    endif()

    # Add libinput and libudev for tablet support on Linux (if available)
    if(LIBINPUT_FOUND AND LIBUDEV_FOUND)
        list(APPEND PLATFORM_LIBS ${LIBINPUT_LIBRARIES} ${LIBUDEV_LIBRARIES})
    endif()

ENDIF(APPLE)

#####
##### COMPILE THE TARGET (all OS)
#####

set_property(TARGET ${VMIX_BINARY} PROPERTY CXX_STANDARD 17)
set_property(TARGET ${VMIX_BINARY} PROPERTY C_STANDARD 11)

# Add src directory to include path so Visitor subfolder files can include without ../
target_include_directories(${VMIX_BINARY} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})

target_compile_definitions(${VMIX_BINARY} PUBLIC "IMGUI_IMPL_OPENGL_LOADER_GLAD")

target_link_libraries(${VMIX_BINARY} LINK_PRIVATE
    ${PLATFORM_LIBS}
    ${GLM_LIBRARIES}
    ${GLAD_LIBRARIES}
    ${OSCPACK_LIBRARIES}
    ${IMGUI_LIBRARIES}
    ${TINYFD_LIBRARIES}
    ${GLFW3_LIBRARIES}
    ${TINYXML2_LIBRARIES}
    ${ICU_LIBRARIES}
    ${CMAKE_DL_LIBS}
    ${GSTREAMER_LIBRARIES}
    Threads::Threads
    ZLIB::ZLIB
    Ableton::Link
    vmix::rc
)

#####
##### DEFINE THE APPLICATION PACKAGING (OS specific)
#####

IF(APPLE)

    set(CPACK_GENERATOR "DragNDrop")
    set(CPACK_BINARY_DRAGNDROP ON)

    set(CPACK_BUNDLE_NAME "vimix.app")
    set(CPACK_BUNDLE_PLIST ${CMAKE_SOURCE_DIR}/osx/Info.plist.in)
    set(CPACK_BUNDLE_ICON  ${CMAKE_SOURCE_DIR}/osx/vimix.icns)
    set(CPACK_BUNDLE_APPLE_CERT_APP ${APPLE_CODESIGN_IDENTITY})
    set(CPACK_BUNDLE_APPLE_ENTITLEMENTS ${APPLE_CODESIGN_ENTITLEMENTS})

    install(TARGETS ${VMIX_BINARY}
            CONFIGURATIONS Release RelWithDebInfo
            BUNDLE  DESTINATION . COMPONENT Runtime
            RUNTIME DESTINATION bin COMPONENT Runtime
    )

    # create GST plugins directory in Bundle Resources subfolder
    set(plugin_dest_dir ${CPACK_BUNDLE_NAME}/Contents/Resources/)

    ### install gst plugins
    message(STATUS "Install with gst-plugins ${PKG_GSTREAMER_PLUGIN_DIR}")
    install(DIRECTORY "${PKG_GSTREAMER_PLUGIN_DIR}" DESTINATION "${plugin_dest_dir}" COMPONENT Runtime)
    list(APPEND GSTPLUGINS_EXCLUDE "libgstgtk4.dylib" "libgstgtk.dylib" "libgstpython.dylib" "libgstnice.dylib")

    # install the gst-plugin-scanner program (used by plugins at load time)
    set(PKG_GSTREAMER_SCANNER "${PKG_GSTREAMER_PREFIX}/libexec/gstreamer-1.0/gst-plugin-scanner")
    message(STATUS "Install with gst-plugin-scanner ${PKG_GSTREAMER_SCANNER}")
    install(FILES "${PKG_GSTREAMER_SCANNER}"
        DESTINATION "${plugin_dest_dir}"
        PERMISSIONS OWNER_READ OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
        COMPONENT Runtime
    )

    # install frei0r plugins (dependencies of gstreamer-1.0/libgstfrei0r.dylib plugin)
    pkg_check_modules(FREI0R QUIET frei0r)
    set(PKG_FREI0R_PLUGIN_DIR ${FREI0R_LIBDIR}/frei0r-1)
    message(STATUS "Install with frei0r plugins ${PKG_FREI0R_PLUGIN_DIR}")
    install(DIRECTORY "${PKG_FREI0R_PLUGIN_DIR}" DESTINATION "${plugin_dest_dir}" COMPONENT Runtime)

    # package runtime fixup bundle
    set(APPS "\${CMAKE_INSTALL_PREFIX}/${CPACK_BUNDLE_NAME}")

    ##
    ## APPLE BUNDLE FIX
    ## with install_name_tool using cmake 'fixup_bundle'
    ##
    install(CODE "
        file(GLOB_RECURSE GSTPLUGINS \"\${CMAKE_INSTALL_PREFIX}/${plugin_dest_dir}/gstreamer-1.0/*.dylib\")
        foreach(PLUGIN \${GSTPLUGINS})
            set(ADD_PLUGIN true)
            foreach(EXCLUDED ${GSTPLUGINS_EXCLUDE})
                string(FIND \${PLUGIN} \${EXCLUDED} _found)
                if(NOT \${_found} EQUAL -1)
                    file(REMOVE \${PLUGIN})
                    set(ADD_PLUGIN false)
                endif()
            endforeach()
            if(ADD_PLUGIN)
                list(APPEND ALLPLUGINS \${PLUGIN})
            endif()
        endforeach()
        file(GLOB FREI0RPLUGINS \"\${CMAKE_INSTALL_PREFIX}/${plugin_dest_dir}/frei0r-1/*.so\")
        list(APPEND ALLPLUGINS \${FREI0RPLUGINS} )
        list(LENGTH ALLPLUGINS SIZE)
        message(\"       - Adding \${SIZE} plugins to bundle...\")
        include(BundleUtilities)
        set(BU_CHMOD_BUNDLE_ITEMS TRUE)
        fixup_bundle(\"${APPS}\" \"\${ALLPLUGINS}\" \"/opt/homebrew/lib;${ICU_LIBRARY_DIRS}\" IGNORE_ITEM \"Python\")
        file(REMOVE_RECURSE \"${APPS}/Contents/Frameworks/Python.framework\")
        "
        COMPONENT Runtime
    )

    ##
    ## APPLE CODE SIGNING
    ## Sign the bundle and ALL binary (executables and dynamic library)
    ##
    string(LENGTH "${APPLE_CODESIGN_IDENTITY}" APPLE_CODESIGN_IDENTITY_LENGHT)
    if( ${APPLE_CODESIGN_IDENTITY_LENGHT} LESS 40 )
        message(STATUS "Not signing bundle. Specify APPLE_CODESIGN_IDENTITY to cmake before running cpack if you want to sign the bundle")
    else()
        message(STATUS "Signing bundle with identity " ${APPLE_CODESIGN_IDENTITY})
        install(CODE "
                cmake_policy(VERSION 3.8)
                file(GLOB_RECURSE DEPENDENCIES ${APPS}/Contents/*.dylib)
                file(GLOB_RECURSE SO_DEPENDENCIES ${APPS}/Contents/*.so)
                list(APPEND DEPENDENCIES \${SO_DEPENDENCIES})
                foreach(DEP \${DEPENDENCIES})
                    execute_process(COMMAND
                        codesign --verify --verbose=0 --force
                        --sign \"${APPLE_CODESIGN_IDENTITY}\"
                        \"\${DEP}\"
                    )
                endforeach()
                list(LENGTH DEPENDENCIES SIZE)
                message(\" - \${SIZE} dependency libraries signed.\")
                message(\" - Signing executables in ${APPS}\")
                execute_process(COMMAND
                    codesign -vvv --force
                    --options runtime --timestamp
                    --entitlements \"${APPLE_CODESIGN_ENTITLEMENTS}\"
                    --sign \"${APPLE_CODESIGN_IDENTITY}\"
                    \"${APPS}/Contents/MacOS/vimix\"
                    \"${APPS}/Contents/Resources/gst-plugin-scanner\"
                )
                message(\" - Signing bundle ${APPS}\")
                execute_process(COMMAND
                    codesign -vvv --force --strict
                    --options runtime --timestamp
                    --entitlements \"${APPLE_CODESIGN_ENTITLEMENTS}\"
                    --sign \"${APPLE_CODESIGN_IDENTITY}\"
                    \"${APPS}\"
                )
                "
                COMPONENT Runtime
        )
    endif()

    ##
    ## APPLE NOTARIZATION
    ## Custom target to sign, notarize, and staple the DMG after cpack
    ## Usage: cmake --build . --target notarize
    ##
    set(DMG_NAME "${CPACK_PACKAGE_FILE_NAME}.dmg")
    add_custom_target(notarize
        COMMAND ${CMAKE_COMMAND}
            -DDMG_PATH=${CMAKE_BINARY_DIR}/${DMG_NAME}
            -DCODESIGN_IDENTITY=${APPLE_CODESIGN_IDENTITY}
            -DKEYCHAIN_PROFILE=vimix
            -P ${CMAKE_SOURCE_DIR}/osx/notarize.cmake
        COMMENT "Signing and notarizing DMG..."
        USES_TERMINAL
        VERBATIM
    )

ELSE(APPLE)

=== debian/changelog ===
vimix (0.9.0+ds-2) unstable; urgency=medium

  * d/control: actually add libgstreamer-plugins-bad1.0-dev.

 -- Alex Myczko <tar@debian.org>  Wed, 18 Feb 2026 08:24:58 +0000

vimix (0.9.0+ds-1) unstable; urgency=medium

  * New upstream version.
  * d/copyright: bump years.
  * d/watch: bump to version 5.
  * d/control:
    - add libgstreamer-plugins-bad1.0-dev to build-depends.
    - drop Rules-Requires-Root.
  * d/patches: dropped.
  * Bump standards version to 4.7.3.

 -- Alex Myczko <tar@debian.org>  Wed, 18 Feb 2026 06:47:32 +0000

=== debian/watch ===
Version: 5

# GitHub hosted projects
Template: Github
Owner: brunoherbelin
Project: vimix
Update-Script: uupdate

## vimix 0.9.0+git20260228+ds

=== debian/changelog ===
vimix (0.9.0+git20260228+ds-1) unstable; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Wed, 18 Feb 2026 08:24:58 +0000

=== debian/control ===
Source: vimix
Section: video
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Alex Myczko <tar@debian.org>
Build-Depends: debhelper-compat (= 13),
 ableton-link-dev,
 cmake,
 fonts-roboto-unhinted, fonts-hack,
 gstreamer1.0-libav,
 libpng-dev,
 libglfw3-dev,
 libgstreamer1.0-dev,
 libgstreamer-plugins-base1.0-dev,
 libicu-dev,
 libglm-dev,
 libgtk-3-dev,
 libstb-dev,
 libtinyxml2-dev,
 libgstreamer-plugins-bad1.0-dev,
Standards-Version: 4.7.3
Homepage: https://brunoherbelin.github.io/vimix/
Vcs-Browser: https://salsa.debian.org/multimedia-team/vimix
Vcs-Git: https://salsa.debian.org/multimedia-team/vimix.git

Package: vimix
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 fonts-roboto-unhinted, fonts-hack
Description: Live Video Mixer
 This performs graphical mixing and blending of several movie clips and computer
 generated graphics, with image processing effects in real-time.
 .
 Its intuitive and hands-on user interface gives direct control on image opacity
 and shape for producing live graphics during concerts and VJ-ing sessions.
 .
 The output image is typically projected full-screen on an external monitor or a
 projector, but can be recorded live (no audio).
